import { Cluster, PrismaDefinitionClass } from 'prisma-yml';
import { GraphQLClient } from 'graphql-request';
import IDatabaseClient from '../IDatabaseClient';
import { DatabaseType } from 'prisma-datamodel';
export declare class PrismaDBClient implements IDatabaseClient {
    cluster: Cluster;
    client: GraphQLClient;
    definition: PrismaDefinitionClass;
    databaseType: DatabaseType;
    constructor(definition: PrismaDefinitionClass);
    query(query: string, variables: string[]): Promise<any[]>;
    getDatabases(): Promise<string[]>;
    protected setDatabaseType(): Promise<void>;
    replace(query: string, variables?: string[]): string;
    connect(): Promise<void>;
    end(): Promise<void>;
}
